<?
/*
 ************************************************************************
 * File Name   : KCBoardTopList.php
 * Class Name  : KCBoardTopList
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KBOARDENV"))        require("../KBoardEnv.php");
if(!defined("KCBOARDUI"))        require(KBOARD_CLASS . "/KCBoardUI.php");
if(!defined("KCBOARDSQLCLAUSE")) require(KBOARD_CLASS . "/KCBoardSqlClause.php");
if(!defined("KCBOARDSEARCHSB"))  require(KBOARD_CLASS . "/KCBoardSearchSB.php");
if(!defined("KCTEXTBOX"))        require(K_LIB_PATH   . "/KCTextBox.php");
if(!defined("KCSTRING"))         require(K_LIB_PATH   . "/KCString.php");
if(!defined("KCCATEGORYSB"))     require(KBOARD_CLASS . "/KCCategorySB.php");
if(!defined("KCBOARD"))          require(KBOARD_CLASS . "/KCBoard.php");

define("KCBOARDLIST", true);
class KCBoardList extends KCBoardUI
{
    var $m_SubjectLength ;
    var $m_Category;
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCBoardList()
    {
        $this->KCBoardUI();
        $this->m_ViewTitleImage = false;
        $this->m_SubjectLength = 47;
        $this->m_Category    = new KCCategorySB("Category");
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function BoardTemplate()
    {
        $this->SetTemplate($this->m_BoardManager->m_TplList);
        $this->SetBlock("category", "tcategory");
        $this->SetBlock("tit_delete", "ttit_delete");
        $this->SetBlock("check_delete", "tcheck_delete");
        $this->SetBlock("btn_delete", "tbtn_delete");        
        $this->SetBlock("tit_upload", "ttit_upload");
        $this->SetBlock("list_upload", "tlist_upload");
        $this->SetBlock("row", "rows");
        $this->SetBlock("empty", "tempty");              
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function ExtraCheckWebParameter()
    {
        $this->CheckPagePerm($this->m_BoardManager->m_AuthList)
        ;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetBoardUIValue()
    {        
        // Table Idx   
        if($this->m_TableIdx != "")
        {
            $this->m_Template->set_var("TABLEID", $this->m_TableIdx);
        }
        
        // Category  ߰ 
        if($this->m_BoardManager->m_UseCategory == "T")
        {
            $this->m_Template->parse("tcategory", "category");
            $this->m_Category->SetAttribute("onchange", "SelectCategory(this)");
            $this->m_Category->LoadData($this->m_BoardTable);
            $Category = $this->m_Category->SBBind($this->m_CategoryValue);
        }
        //   ߰ 
        if($this->IsAdmin())
        {
            $this->m_Template->parse("ttit_delete", "tit_delete");
            $this->m_Template->parse("tcheck_delete", "check_delete");
            $this->m_Template->parse("tbtn_delete", "btn_delete");
            
            /*
            $this->m_Template->set_var(array(
                "tcheck_delete" => $this->m_Template->get_var("check_delete"),
                "tbtn_delete"   => $this->m_Template->get_var("btn_delete")
            ));            
            */
        }
        // Upload  ߰ 
        if($this->m_BoardManager->m_MaxUpload > 0)
        {
            $this->m_Template->parse("ttit_upload", "tit_upload");
            $this->m_Template->parse("tlist_upload", "list_upload");
        }
        
        
        // Default  ߰ 
        $this->m_Template->set_var(array(
            TABLENAME        => $this->m_BoardTable,
            SEARCH_SELECTBOX => $this->LoadSearchForm(),
            SEARCH_VALUE     => $this->LoadSearchText(),
            CATEGORYSB       => $Category,
            CATEGORYVALUE    => $this->m_CategoryValue
        ));        
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetInitData()
    {
        $this->BoardList();
    }


    /* --------------------------------------------------
     * access : private
     *
     * -------------------------------------------------- */
    function LoadSearchForm()
    {
        $SearchSB = new KCBoardSearchSB("sf");
        $SearchSB->SetAttribute("style", "width:70;");
        $SearchSB->LoadData();
        return $SearchSB->SBBind($this->m_SearchField);
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function LoadSearchText()
    {
        $SearchText = new KCTextBox("sw",$this->m_SearchWord);
        $SearchText->SetAttribute("class", "forms");
        $SearchText->SetAttribute("style", "width:120px;");
        return $SearchText->GetValue();
    }


    /* --------------------------------------------------
     * access :
     * step ̿Ͽ  Ʈ    Ʈ 
     * -------------------------------------------------- */
    function  GetSubjectSpace($Step)
    {
        for($i = 0 ; $i < $Step ;$i ++)
        {
            $Space .="&nbsp;&nbsp;";
        }
        if($Step > 0)
        {
            $Space .= "<img src='image/reply_icon.gif'> ";
        }
        return $Space ;
    }



    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function BoardList()
    {
        $DbMan = new KCDbSql;
        $SqlClause = new KCBoardSqlClause($this->m_BoardTable);
        //$SqlClause->SetTable(" `$this->m_BoardTable` Board, bl_Upload KU" );
        if($this->m_BoardManager->m_UseCategory == "T")
        {            
            $SqlClause->SetTable(" `$this->m_BoardTable` as BT INNER JOIN `" .$this->m_BoardTable. "_Category` KC ON BT.Category = KC.Idx
                                   LEFT OUTER JOIN `" . $this->m_BoardTable. "_Comment` BCT ON BT.Id = BCT.PIdx
                                ");
        }        
        else
        {
            $SqlClause->SetTable(" `$this->m_BoardTable` as BT  
                                 LEFT OUTER JOIN `" . $this->m_BoardTable. "_Comment` BCT ON BT.Id = BCT.PIdx
                        " );            
        }
        
        $SqlClause->SetField("BT.Id, BT.Name, BT.EMail, BT.Subject, BT.Step,  UNIX_TIMESTAMP(BT.Wdate) as Wdate, BT.Hit, BT.TopOrder, BT.Category, count(BCT.PIdx) AS CommentCount, BT.Pds ");
        $SqlClause->SetGroupBy("GROUP BY BT.Name , BT.EMail , BT.Subject, Wdate, BT.Hit, BCT.PIdx");

        //˻ Query  ֱ
        if($this->m_SearchFlag)
        {
            $FieldFlag = true;
            $EqualOperator  = false;
            switch(strtolower($this->m_SearchField))
            {
                //񿡼 ã
                case $this->SEARCH_FIELD_SUBJECT:
                    $FieldName = "Subject";
                    break;
                //뿡 ã
                case $this->SEARCH_FIELD_CONTENTS:
                    $FieldName = "Contents";
                    break;
                //ۼڿ ã
                case $this->SEARCH_FIELD_NAME:
                    $FieldName = "Name";
                    break;
                default :
                    $FieldFlag = false;
            }
            if($FieldFlag)
            {
                if($EqualOperator)
                {
                    $SqlClause->SetWhere("BT.$FieldName = '$this->m_SearchWord%' ");
                }
                else
                {
                    $SqlClause->SetWhere("BT.$FieldName like '%$this->m_SearchWord%' ");
                }
            }            

        }
        
        if($this->m_CategoryValue > 0 )
        {
            $SqlClause->SetWhere("BT.Category = '$this->m_CategoryValue' ");                
        }
        
        $SqlClause->SetOrder(" ORDER BY TopOrder desc, Ref desc, ReLevel ");        
        $Result = $DbMan->query($SqlClause->GetListQuery($this->m_BoardManager->m_ListPerPage));
        if($Result)
        {   
            if($DbMan->nf() > 0)
            {

                $String       = new KCString;
                $DefaultParam = $this->m_PageManager->GetHiddenParam();
                $StartNum     = $SqlClause->GetStartListNum();
                $ListNumber   = 0;
                while($DbMan->next_record())
                {
                    $TdAttr = "";
                    if(($ListNumber % 2) == 1)
                        $TdAttr = "bgcolor=\"#F2F2EE\"";

                    $TopStyle = "";
                    if($DbMan->f("TopOrder") > 0)
                    {
                        $TopStyle = "class=new";
                    }                    
                    
                    if($DbMan->f("CommentCount") != "0" )
                    {                        
                        $CommentCount = "[" . $DbMan->f("CommentCount") . "]";                        
                    }
                    else
                    {
                        $CommentCount = "";                        
                    }                 
                    
                    $ReSpace = $this->GetSubjectSpace($DbMan->f("Step"));
                    $this->m_Template->set_var( array(
                        NUMBER   => $StartNum,
                        CATEGORY => $Category,
                        ID       => $DbMan->f("Id"),
                        RESPACE  => $ReSpace,
                        SUBJECT  => $this->MarkSearchWord(" " . $String->GetLimitStr($DbMan->f("Subject"), $this->m_SubjectLength), $this->SEARCH_FIELD_SUBJECT),
                        COMCOUNT => $CommentCount,
                        NAME     => $this->MarkSearchWord($DbMan->f("Name"),    $this->SEARCH_FIELD_NAME),
                        WDATE    => date("m/d", $DbMan->f("Wdate")),
                        PDS      => $DbMan->f("Pds"),
                        HIT      => $DbMan->f("Hit"),
                        TDATTR   => $TdAttr,
                        TOPSTYLE => $TopStyle
                    ));
                    $this->m_Template->parse("rows", "row", true);
                    $StartNum -- ;
                    $ListNumber ++;
                }
                
            }
            else
            {
                $this->m_Template->parse("rows", "empty", true);
            }
        }
        $this->m_Template->set_var(array(
            "PAGENUMBER" => $SqlClause->PrintPageNum()
        ));
    }
    
    /* --------------------------------------------------
     * access : private
     * event function 
     * -------------------------------------------------- */
    function DeleteRow()
    {
        global $HTTP_POST_VARS;
        if($this->IsAdmin())
        {
            $Board = new KCBoard($this->m_BoardTable);
            $Idxs = $HTTP_POST_VARS["deleteId"];        
            for( $i = 0 ; $i < count($Idxs) ; $i ++)
            {
                if(!$Board->DeleteData($Idxs[$i]))
                {
                    $this->m_JSUtil->AlertBack("   ߻߽ϴ.");
                    break;
                }
            }            
        }
        $this->GoNextPage("BoardList.php");
        exit;
    }
}
?>