<?
/*
 ************************************************************************
 * File Name   : KCBoardView.php
 * Class Name  : KCBoardView
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KBOARDENV"))       require("../KBoardEnv.php");
if(!defined("KCBOARDUI"))       require(KBOARD_CLASS . "/KCBoardUI.php");
if(!defined("KCBOARD"))         require(KBOARD_CLASS . "/KCBoard.php");
if(!defined("KCUPLOAD"))        require(KBOARD_CLASS . "/KCUpload.php");
if(!defined("KCBOARDCOMMENT"))  require(KBOARD_CLASS . "/KCBoardComment.php");
define("KCBOARDVIEW", true);
class KCBoardView extends KCBoardUI
{
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCBoardView()
    {
        $this->KCBoardUI();
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function BoardTemplate()
    {
        $this->SetTemplate($this->m_BoardManager->m_TplView);
        $this->SetBlock("row", "rows");
        $this->SetBlock("empty", "tempty");
        $this->SetBlock("datcomment", "tdatcomment");
        $this->SetBlock("uploadlist", "tuploadlist");
    }


    /* --------------------------------------------------
     * access : protected
     *
     * -------------------------------------------------- */
    function SetInitData()
    {
        $this->LoadBoardData();        
    }


    /* --------------------------------------------------
     * access : protected
     *
     * -------------------------------------------------- */
    function ExtraCheckWebParameter()
    {
        $this->CheckPagePerm($this->m_BoardManager->m_AuthView);
        if(!$this->m_IsSetKey)
        {
            $this->m_CheckData->SetCheckValue("-1", "-1", "  ϴ.");
        }
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetBoardUIValue()
    {        
        if($this->IsAdmin())
        {
            $IsAdmin = "true";
        }
        else
        {
            $IsAdmin = "false";
        }
        
        $this->m_Template->set_var(array(
                "TID" => $this->m_TableIdx,
                "ISADMIN" => $IsAdmin,
                "USERNAME"    => $this->m_Auth->GetName()
                ));
        if($this->m_BoardManager->m_MaxUpload > 0)
        {
            $this->m_Template->parse("tuploadlist", "uploadlist");
        }                
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetNextPrePage($TId)
    {
        $Ret = "";
        if($TId != "-1")
        {
            $Ret = "BoardView.php?". $this->m_PageManager->GetHiddenParam() ."&tId=$TId";
        }
        else
        {
            $Ret = "javascript: alert(' ϴ.')";
        }
        return $Ret;
    }



    /* --------------------------------------------------
     * access : private
     *
     * -------------------------------------------------- */
    function LoadBoardData()
    {        
        global $HTTP_REFERER;
        $Board = new KCBoard($this->m_BoardTable);

        // --------------------------------------------------
        // Reloadϴ  ȸ  
        // HTTP_REFERER     
        // εǾ  ȸ  ʴ´.
        if(!strstr($HTTP_REFERER,"tId=$this->m_TableIdx"))
        {
            if(!$Board->IncreaseHit($this->m_TableIdx))
            {
                $this->m_ErrMsg = "$this->m_BoardTable, ID $this->m_TableIdx ȸ ";
                $this->PrintError($this->m_ErrMsg);
            }
        }

        if($Board->LoadData($this->m_TableIdx))
        {
            $PreRef  = $this->GetNextPrePage($Board->GetPreId());
            $NextRef = $this->GetNextPrePage($Board->GetNextId());
            if($Board->m_Homepage != "")
            {
                $Homepage = "$Board->m_Homepage";
            }
            else
            {
                $Homepage = "#";                
            }
            
            $this->m_Template->set_var(array(
                ID       => $Board->m_Id,
                SUBJECT  => $this->MarkSearchWord($Board->m_Subject, $this->SEARCH_FIELD_SUBJECT),
                NAME     => $this->MarkSearchWord($Board->m_Name,    $this->SEARCH_FIELD_NAME),
                HOMEPAGE => $Homepage,
                EMAIL    => $Board->GetEMail(),
                CONTENTS => str_replace("\n", "<br style='line-height:25px;'>", $this->MarkSearchWord($Board->GetContents(), $this->SEARCH_FIELD_CONTENTS)),
                WDATE    => $Board->m_Vdate,
                IP       => $Board->m_Ip,
                HIT      => $Board->m_Hit,
                PREREF   => $PreRef,
                NEXTREF  => $NextRef

            ));
            if($this->m_BoardManager->m_LimitStep != "-1" && $this->m_BoardManager->m_LimitStep <= $Board->m_Step)
            {
                $this->SetBlock("reply", "treply");
            }
            if($this->m_BoardManager->m_MaxUpload > 0 )
            {
                $this->LoadUploadFile();
            }
            $this->LoadDatComment();
        }
        else
        {
            $this->m_ErrMsg = "$this->m_BoardTable, ID $this->m_TableIdx  б⿡ ߽ϴ.";
            $this->PrintError($this->m_ErrMsg);
        }
    }


    /* --------------------------------------------------
     * access : private
     *
     * -------------------------------------------------- */
    function LoadUploadFile()
    {
        $Query = "SELECT * FROM `" . $this->m_BoardTable. "_Upload` WHERE BoardId = '$this->m_TableIdx'";
        $DbMan = new KCDbSql;
        if($DbMan->query($Query))
        {
            if($DbMan->nf() > 0)
            {
                $RowNum = 1;
                while($DbMan->next_record())
                {
                    $this->m_Template->set_var(array(
                        ROWNUM   => $RowNum,
                        UPLOADID => $DbMan->f("Id"),
                        FILENAME => $DbMan->f("FileName"),
                        FILESIZE => $this->GetFormat($DbMan->f("FileSize")),
                        DOWNLOAD => $DbMan->f("DownLoad")
                    ));
                    $this->m_Template->parse("rows", "row", true);
                    $RowNum ++;
                }
            }
            else
            {
                $this->m_Template->parse("rows", "empty", true);
            }

        }
        else
        {
            $this->m_ErrMsg = " Upload File µ ߽ϴ.";
            $this->PrintError($this->m_ErrMsg);
        }
    }


    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function LoadDatComment()
    {
        $Query = "SELECT * FROM `" . $this->m_BoardTable. "_Comment` WHERE PIdx = '$this->m_TableIdx'";
        $DbMan = new KCDbSql;
        if($DbMan->query($Query))
        {
            if($DbMan->nf() > 0)
            {
                while($DbMan->next_record())
                {                    
                    $this->m_Template->set_var(array(
                        CIDX       => $DbMan->f("Idx"),
                        WRITER     => $DbMan->f("Writer"),
                        DATCOMMENT => nl2br($DbMan->f("DatComment")),
                        REGDATE    => $DbMan->f("RegDate")
                    ));
                    $this->m_Template->parse("tdatcomment", "datcomment", true);
                }
            }
            else
            {
                //$this->m_Template->parse("tdatcomment", "empty", true);
            }

        }
        else
        {
            $this->m_ErrMsg = "  µ ߽ϴ.";
            $this->PrintError($this->m_ErrMsg);
        }        
    }

    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function DeleteData()
    {
        global $HTTP_POST_VARS;
        $Board = new KCBoard($this->m_BoardTable);

        //  ׳ ٷ    
        if($this->IsAdmin())
        {
            $Board->DeleteData($this->m_TableIdx);
        }
        else
        {
            //ڰ ƴ  н带 ˻Ѵ.
            if($Board->CheckPassword($this->m_TableIdx, $HTTP_POST_VARS["Passwd"]))
            {
                $Board->DeleteData($this->m_TableIdx);                
            }
            else
            {
                $this->m_JSUtil->AlertBack("н尡 ġ ʽϴ.");
            }
        }
        $this->GoNextPage("BoardList.php");
    }
    
    
    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */        
    function DeleteComment()
    {
        global $HTTP_POST_VARS;        
        $BoardComment = new KCBoardComment($this->m_BoardTable);
        if($this->IsAdmin())
        {
            if(!$BoardComment->DeleteData($HTTP_POST_VARS["CIdx"]))
            {
                $this->m_JSUtil->AlertBack("   ߻߽ϴ.");                                           
            }            
        }
        else
        {
            if($BoardComment->CheckPasswd($HTTP_POST_VARS["CIdx"], $HTTP_POST_VARS["CommandDeletePasswd"]))
            {
                if(!$BoardComment->DeleteData($HTTP_POST_VARS["CIdx"]))
                {
                    $this->m_JSUtil->AlertBack("   ߻߽ϴ.");                                           
                }
            }
            else
            {
                $this->m_JSUtil->AlertBack("н尡 ġ ʽϴ.");                           
            }            
        }
        

        $this->GoCurrentPage();        
    }
    
    
    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */    
    function AddComment()
    {
        global $HTTP_POST_VARS;
        $DataValue = $HTTP_POST_VARS;
        $DataValue["PIdx"] = $this->m_TableIdx;
        $BoardComment = new KCBoardComment($this->m_BoardTable);
        $BoardComment->SetDataValue($DataValue);        
        if(!$BoardComment->InsertData())
        {
            $this->m_JSUtil->AlertBack(" Է ");               
        }
        $this->GoCurrentPage();
        exit;
    }
}
?>
