<?
/*
 ************************************************************************
 * File Name   : KCBoardWrite.php
 * Class Name  : KCBoardWrite
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KBOARDENV"))     require("../KBoardEnv.php");
if(!defined("KCBOARDUI"))     require(KBOARD_CLASS . "/KCBoardUI.php");
if(!defined("KCTEXTBOX"))     require(K_LIB_PATH   . "/KCTextBox.php");
if(!defined("KCPASSWORDBOX")) require(K_LIB_PATH   . "/KCPasswordBox.php");
if(!defined("KCCHECKBOX"))    require(K_LIB_PATH   . "/KCCheckBox.php");
if(!defined("KCTEXTAREA"))    require(K_LIB_PATH   . "/KCTextArea.php");
if(!defined("KCFILEUPLOAD"))  require(KBOARD_CLASS . "/KCFileUpload.php");
if(!defined("KCCATEGORYSB"))  require(KBOARD_CLASS . "/KCCategorySB.php");
if(!defined("KCBOARD"))       require(KBOARD_CLASS . "/KCBoard.php");
if(!defined("KCTOPORDERSB"))  require(KBOARD_CLASS . "/KCTopOrderSB.php");


define("KCBOARDWRITE", true);
class KCBoardWrite extends KCBoardUI
{
    var $m_Name;
    var $m_Category;
    var $m_EMailID;
    var $m_EMailServer;
    var $m_Homepage;
    var $m_Subject;
    var $m_Contents;
    var $m_Passwd;
    var $m_TopOrder;
    var $m_ViewHtml;
    var $m_Operation ;
    var $m_ReplyFlag;
    var $B_OPERATION_INSERT = "0";
    var $B_OPERATION_UPDATE = "1";
    var $B_OPERATION_REPLY  = "2";


    var $m_MaxUpload = 0;

    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCBoardWrite()
    {
        $this->KCBoardUI();
        $this->m_ReplyFlag   = false;
        $this->m_Operation   = $this->B_OPERATION_INSERT;
        $this->m_Name        = new KCTextBox("Name");
        $this->m_Category    = new KCCategorySB("Category");
        $this->m_EMailID     = new KCTextBox("EMailID");
        $this->m_EMailServer = new KCTextBox("EMailServer");
        $this->m_Homepage    = new KCTextBox("Homepage");
        $this->m_Subject     = new KCTextBox("Subject");
        $this->m_Contents    = new KCTextArea("Contents");
        $this->m_Passwd      = new KCPasswordBox("Passwd");
        $this->m_TopOrder    = new KCTopOrderSB("TopOrder");
        $this->m_ViewHtml    = new KCCheckBox("ViewHtml", "T");
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function BoardTemplate()
    {
        $this->SetTemplate($this->m_BoardManager->m_TplWrite);
        $this->SetBlock("row", "rows");
        $this->SetBlock("empty", "tempty");
        $this->SetBlock("addupload", "taddupload");
        $this->SetBlock("upload", "tupload");
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * reply flag  ˻մϴ.
     * -------------------------------------------------- */
    function SetExtraWebParameter()
    {
        global $HTTP_GET_VARS;
        if($HTTP_GET_VARS["rf"] == "t")
        {
            $this->m_ReplyFlag = true;
        }

        if($this->m_IsSetKey)
        {
            if($this->m_ReplyFlag)
            {
                $this->m_Operation = $this->B_OPERATION_REPLY;
            }
            else
            {
                $this->m_Operation = $this->B_OPERATION_UPDATE;
            }
        }
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function ExtraCheckWebParameter()
    {
        $this->CheckPagePerm($this->m_BoardManager->m_AuthInput);
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetBoardUIValue()
    {
        // ε 
        if($this->m_BoardManager->m_MaxUpload > 0)
        {
            $this->m_Template->set_var("tupload", $this->m_Template->get_var("upload"));
        }
        $this->m_MaxUpload = $this->m_BoardManager->m_MaxUpload;

        // Upload Command 
        if($this->m_Operation == $this->B_OPERATION_UPDATE)
        {
            $this->m_Template->set_var("COMMAND", "UpdateBoard");
            $this->m_Template->set_var("UPDATEFLAG", "true");
        }
        // Insert command 
        else
        {
            $this->m_Template->set_var("COMMAND", "InsertBoard");
            $this->m_Template->set_var("UPDATEFLAG", "false");
        }

        if($this->IsAdmin())
        {
            $this->m_Template->set_var("ADMINFLAG", "true");
        }
        else
        {
            $this->m_Template->set_var("ADMINFLAG", "false");
            $this->m_TopOrder->SetAttribute("disabled", "true");
        }

        if($this->m_BoardManager->m_AuthInput != "nobody")
        {
            $this->m_Template->set_var("NAMEREADONLY", "readonly");
        }
    }



    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetInitData()
    {
        if($this->m_Operation == $this->B_OPERATION_UPDATE)
        {
            $this->LoadBoardValue();
            $this->LoadUploadFile();
        }
        else
        {
            $this->m_Name->SetValue($this->m_Auth->GetName());
        }
        $this->DefaultBoardValue();
    }


    /* --------------------------------------------------
     * access : private
     *
     * -------------------------------------------------- */
    function DefaultBoardValue()
    {
        $this->m_Category->LoadData($this->m_BoardTable);
        $this->m_TopOrder->LoadData($this->m_BoardTable);

        // Category  
        if($this->m_BoardManager->m_UseCategory == "T")
        {
            $Category = $this->m_Category->SBBind("-1");
        }
        else
        {
            $Category = "<Input type=hidden name='Category' value='1'>";
        }
        $this->m_Template->set_var(array(
            NAME          => $this->m_Name->GetValue(),
            CATEGORY      => $Category,
            EMAILID       => $this->m_EMailID->GetValue(),
            EMAILSERVER   => $this->m_EMailServer->GetValue(),
            HOMEPAGE      => $this->m_Homepage->GetValue(),
            SUBJECT       => $this->m_Subject->GetValue(),
            CONTENTS      => $this->m_Contents->GetContents(),
            PASSWD        => $this->m_Passwd->GetValue(),
            TOPORDER      => $this->m_TopOrder->SBBind(),
            VIEWHTML      => $this->m_ViewHtml->GetValue(),
            VIEWCHECKED   => $this->m_ViewHtml->GetChecked()
        ));


        // ߰  ִ ε尡  ȭ 
        if($this->m_MaxUpload > 0)
        {
            $this->m_Template->parse("taddupload", "addupload");            
            $this->m_Template->set_var("UPLOAD_MAX", $this->m_MaxUpload);
        }
    }


    /* --------------------------------------------------
     * access : private
     *
     * -------------------------------------------------- */
    function LoadBoardValue()
    {
        $Board = new KCBoard($this->m_BoardTable);
        if($Board->LoadData($this->m_TableIdx))
        {
            $this->m_Name->SetValue($Board->m_Name);
            $this->m_EMailID->SetValue($Board->GetEMailID());
            $this->m_EMailServer->SetValue($Board->GetEMailServer());
            $this->m_Homepage->SetValue($Board->m_Homepage);
            $this->m_Subject->SetValue($Board->m_Subject);
            $this->m_Contents->SetText($Board->m_Contents);
            $this->m_TopOrder->SetDefaultValue($Board->m_TopOrder);
            $this->m_Category->SetDefaultValue($Board->m_Category);
            $this->m_ViewHtml->CheckValue("T", $Board->m_ViewHtml);
        }
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function LoadUploadFile()
    {
        $Query = "SELECT * FROM `" . $this->m_BoardTable. "_Upload` WHERE BoardId = '$this->m_TableIdx'";
        $DbMan = new KCDbSql;
        if($DbMan->query($Query))
        {
            if($DbMan->nf() > 0)
            {
                $RowNum = 1;
                while($DbMan->next_record())
                {
                    $this->m_Template->set_var(array(
                        ROWNUM   => $RowNum,
                        UPLOADID => $DbMan->f("Id"),
                        FILENAME => $DbMan->f("FileName"),
                        FILESIZE => $this->GetFormat($DbMan->f("FileSize")),
                        DOWNLOAD => $DbMan->f("DownLoad")
                    ));
                    $this->m_Template->parse("rows", "row", true);
                    $RowNum ++;

                    //
                    $this->m_MaxUpload --;
                }
            }
            else
            {
                $this->m_Template->parse("rows", "empty", true);
            }
        }
        else
        {
            $this->m_ErrMsg = " Upload File µ ߽ϴ.";
            $this->PrintError($this->m_ErrMsg);
        }
    }


    /* --------------------------------------------------
     * access : private
     * Event function
     * -------------------------------------------------- */
    function InsertBoard()
    {
        global $HTTP_POST_VARS;
        global $REMOTE_ADDR;
        $UploadFile = new KCFileUpload(UPLOAD_PATH . "/$this->m_BoardTable");
        //ϴ ε Ͽ ؼ ˻縦 Ѵ.
        if($UploadFile->CheckUploadFile())
        {
            $Board = new KCBoard($this->m_BoardTable, $this->m_ReplyFlag, $this->m_TableIdx);
            $Board->SetDataValue($HTTP_POST_VARS, $REMOTE_ADDR);

            //Ÿ Ѵ.
            if(!$Board->InsertData())
            {
                $this->PrintError($Board->m_ErrMsg);
                $this->m_JSUtil->AlertBack("Էµ  ߻߽ϴ.");
            }
            //Ÿ    Ѵ.
            else
            {
                $NewId = $Board->GetNewId();
                if($NewId)
                {
                    //  ϰ Table   Ѵ. 
                    if(!$UploadFile->SaveUploadFile($this->m_BoardTable, $NewId))
                    {
                        $this->m_JSUtil->AlertBack($UploadFile->m_ErrMsg);
                    }
                    else
                    {
                        // BoardTable  UploadField  Ʈ Ѵ.          
                        if(!$Board->UpdatePds($NewId))
                        {
                            $this->m_JSUtil->AlertBack(" ε Ʈ ");
                        }
                    }
                }
            }
            $this->GoNextPage("BoardList.php");
        }
        else
        {
            $this->m_JSUtil->AlertBack($UploadFile->m_ErrMsg);
        }
    }


    /* --------------------------------------------------
     * access : private
     * upload  
     * -------------------------------------------------- */
    function DeleteUploadData()
    {
        global $HTTP_POST_VARS;
        $Ret = true;
        //  ˻ 
        $Upload = new KCUpload($this->m_BoardTable);
        $DeleteIds = $HTTP_POST_VARS["DeleteId"];
        for($i = 0 ; $i < count($DeleteIds) ; $i ++ )
        {
            if(!$Upload->DeleteData($this->m_TableIdx, $DeleteIds[$i]))
            {
                $Ret = false;
                $this->m_ErrMsg = "UploadFile  ";
                break;
            }
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : private
     * Event function
     * -------------------------------------------------- */
    function UpdateBoard()
    {
        global $HTTP_POST_VARS;
        $Board = new KCBoard($this->m_BoardTable);
        $UploadFile = new KCFileUpload( UPLOAD_PATH ."/$this->m_BoardTable");
        if($UploadFile->CheckUploadFile())
        {
            if($this->IsAdmin())
            {
                // 
                $Board->SetDataValue($HTTP_POST_VARS);
                //Board Data 
                if($Board->UpdateData($this->m_TableIdx))
                {
                    //ο ε  
                    if(!$UploadFile->SaveUploadFile($this->m_BoardTable, $this->m_TableIdx))
                    {
                        $this->m_JSUtil->AlertBack($UploadFile->m_ErrMsg);
                    }

                    //   DB , File system ,
                    if(!$this->DeleteUploadData())
                    {
                        $this->m_JSUtil->AlertBack($this->m_ErrMsg);
                    }
                    else
                    {
                        // BoardTable  UploadField  Ʈ Ѵ.          
                        if(!$Board->UpdatePds($this->m_TableIdx))
                        {
                            $this->m_JSUtil->AlertBack(" ε Ʈ ");
                        }                                        
                    }
                }
                $this->GoNextPage("BoardList.php");
            }
            else
            {
                // н ˻
                if($Board->CheckPassword($this->m_TableIdx, $HTTP_POST_VARS["Passwd"]))
                {
                    // 
                    $Board->SetDataValue($HTTP_POST_VARS);
                    //Board Data 
                    if($Board->UpdateData($this->m_TableIdx))
                    {
                        //ο ε  
                        if(!$UploadFile->SaveUploadFile($this->m_BoardTable, $this->m_TableIdx))
                        {
                            $this->m_JSUtil->AlertBack($UploadFile->m_ErrMsg);
                        }

                        //   DB , File system ,
                        if(!$this->DeleteUploadData())
                        {
                            $this->m_JSUtil->AlertBack($this->m_ErrMsg);
                        }
                        else
                        {
                            // BoardTable  UploadField  Ʈ Ѵ.          
                            if(!$Board->UpdatePds($this->m_TableIdx))
                            {
                                $this->m_JSUtil->AlertBack(" ε Ʈ ");
                            }                                                                    
                        }
                    }
                    $this->GoNextPage("BoardList.php");
                }
                else
                {
                    $this->m_JSUtil->AlertBack("н尡 ġ ʽϴ.");
                }
            }
        }
        else
        {
            $this->m_JSUtil->AlertBack($UploadFile->m_ErrMsg);
        }
    }
}

?>