<?
/*
 ************************************************************************
 * File Name  : KCManagerList.php
 * Class Name : KCManagerList
 * File Type  : class
 * version    : Version. 0.1.0
 * Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 * All Rights Reserved.
 * http://www.geonji.co.kr/~konlo
 * function   :
 ************************************************************************
 */

if(!defined("KBOARDENV")) require("../KBoardEnv.php");

if(!defined("KCBOARDMANAGERUI")) require(KBOARD_CLASS . "/KCBoardManagerUI.php");
if(!defined("KCSEARCHSB"))       require(KBOARD_CLASS . "/KCSearchSB.php");
if(!defined("KCBOARDMANAGER"))   require(KBOARD_CLASS . "/KCBoardManager.php");
if(!defined("KCTEXTBOX"))        require(K_LIB_PATH   . "/KCTextBox.php");
if(!defined("KCSQLCLAUSE"))      require(K_LIB_PATH   . "/KCSqlClause.php");

define("KCMANAGERLIST", true);
class KCManagerList extends KCBoardManagerUI
{

    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCManagerList()
    {
        $this->KCBoardManagerUI();
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function BoardManagerTemplate()
    {
        $this->SetTemplate("ManagerList.ihtml");
        $this->SetBlock();        
        $this->SetBlock("empty", "tempty");
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetInitData()
    {
        $this->BoardManagerList();
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetManagerUIValue()
    {
        $this->m_Template->set_var(array(
            SEARCH_SELECTBOX => $this->LoadSearchForm(),
            SEARCH_INPUTBOX  => $this->LoadSearchText()
        ));
    }


    /* --------------------------------------------------
     * access : private
     *
     * -------------------------------------------------- */
    function LoadSearchForm()
    {
        $SearchSB = new KCSearchSB("sf", "sf", "sf" );
        $SearchSB->LoadData();
        return $SearchSB->SBBind($this->m_SearchField);
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function LoadSearchText()
    {
        $SearchText = new KCTextBox("sw",$this->m_SearchWord);
        $SearchText->SetAttribute("class", "forms");
        return $SearchText->GetInputBox();
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function BoardManagerList()
    {
        $DbMan = new KCDbSql;
        $SqlClause = new KCSqlClause;
        $SqlClause->SetTable("kb_boardmanager");
        $SqlClause->SetField("*");

        if($this->m_SearchFlag)
        {
            switch(strtolower($this->m_SearchField))
            {
                case "t":
                    $FieldName = "TableName";
                    $SqlClause->SetWhere("$FieldName like '%$this->m_SearchWord%' ");
                    break;
                case "d":
                    $FieldName = "Description";
                    $SqlClause->SetWhere("$FieldName like '%$this->m_SearchWord%' ");
                    break;
                break;
            }
        }

        $Result = $DbMan->query($SqlClause->GetListQuery());
        if($Result)
        {
            if($DbMan->nf() > 0)
            {
                $StartNum = $SqlClause->GetStartListNum();
                $ListCount = 0;
                while($DbMan->next_record())
                {
                    $TdAttr = "";
                    if($ListCount % 2 == 1)
                    {
                        $TdAttr = "bgcolor=\"#F2F2EE\"";
                    }
    
                    $this->m_Template->set_var( array(
                        "NUMBER"       => $StartNum,
                        "TABLE_NAME"   => $DbMan->f("TableName"),                    
                        "DESCRIPTION"  => $DbMan->f("Description"),
                        "TDATTR"       => $TdAttr,
                        "REGDATE"      => $DbMan->f("RegDate")                        
                    ));
                    $this->m_Template->parse("rows", "row", true);
                    $StartNum -- ;
                    $ListCount ++;
                }                
            }
            else
            {
                $this->m_Template->parse("rows", "empty", true);                
            }
            

        }
        $this->m_Template->set_var(array(
            "PAGENUMBER" => $SqlClause->PrintPageNum()
        ));
    }


    /* --------------------------------------------------
     * access : private
     *
     * -------------------------------------------------- */
    function GoNextPage()
    {
        //$this->m_JSUtil->Refresh("./ManagerList.php");

    }


    /* --------------------------------------------------
     * access : public
     * event function;
     * -------------------------------------------------- */
    function AddBoard()
    {
        global $HTTP_POST_VARS;
        $TableName   = $HTTP_POST_VARS["TableName"];
        $Description = $HTTP_POST_VARS["Description"];
        $UseFlag     = $HTTP_POST_VARS["UseFlag"];

        $TableName = "kb_$TableName";
        $BoardManager = new KCBoardManager;
        if($BoardManager->CreateBoard($TableName))
        {
            $BoardManager->SetDefaultDataValue(
                $TableName,
                $Description,
                $UseFlag );
            if(!$BoardManager->InsertData())
            {
                if($BoardManager->m_ErrCode == $BoardManager->MYSQL_ERROR_DUPLICATE)
                {
                    $this->m_JSUtil->AlertBack("Table ̸ ߺ˴ϴ. ٸ ̸ ̿ϼ");
                }
                else
                {
                    $this->m_JSUtil->AlertBack("Էµ  ߻߽ϴ.");
                }
            }
            $this->GoCurrentPage();
        }
        else
        {
            $this->PrintError($BoardManager->m_ErrMsg);
            $this->m_JSUtil->AlertBack("Էµ  ߻߽ϴ. Table ̸ ߸ Ưڰ ֽϴ. ٸ Table ̸ ̿Ͻñٶϴ.");

        }
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function DeleteBoard()
    {
        global $HTTP_POST_VARS;
        $BoardManager = new KCBoardManager;
        if(!$BoardManager->RemoveTable($HTTP_POST_VARS["TableName"]))
        {
            $this->PrintError($BoardManager->m_ErrMsg);
            $this->m_JSUtil->AlertBack("  ߻߽ϴ.");
        }
        $this->GoCurrentPage();
    }
}
?>