<?
/*
 ************************************************************************
 * File Name  : KBoardEnv.php
 * Class Name :
 * version    :
 * Copyright 2001, 2002 Na Jong Sung <konlo@geonji.co.kr>
 * All Rights Reserved.
 * http://www.geonji.co.kr/~konlo
 ************************************************************************
 */

if(!defined("KCDATABASE"))     require(K_LIB_PATH   . "/KCDataBase.php");
if(!defined("KCUPLOAD"))       require(KBOARD_CLASS . "/KCUpload.php");
if(!defined("KCBOARDCOMMENT")) require(KBOARD_CLASS . "/KCBoardComment.php");

define("KCBOARD", true);
/* --------------------------------------------------
 * Board Table ϴ Class
 * -------------------------------------------------- */
class KCBoard extends KCDataBase
{
    var $m_TableName ;
    var $m_Id;
    var $m_Category;
    var $m_Name;
    var $m_EMail;
    var $m_Homepage;
    var $m_Subject;
    var $m_Contents;
    var $m_Passwd;
    var $m_Wdate;
    var $m_Ip;
    var $m_Hit;
    var $m_Ref;
    var $m_Step;
    var $m_ReLevel;
    var $m_Pds;
    var $m_TopOrder;
    var $m_ViewHtml;
    var $m_Vdate;         // view date
    var $m_NewId;
    var $m_ReplyFlag;
    var $m_ReplyId;


    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCBoard($TableName, $ReplyFlag= false, $ReplyId = 0)
    {
        $this->KCDataBase();
        $this->m_TableName = $TableName;
        $this->m_ReplyFlag = $ReplyFlag;
        $this->m_NewId     = false;
        $this->m_ReplyId   = $ReplyId;
    }


    /* --------------------------------------------------
     * access : public
     * override
     * -------------------------------------------------- */
    function GetSelectSQL($Id)
    {
        return "SELECT *, UNIX_TIMESTAMP(Wdate) as Vdate FROM `$this->m_TableName` WHERE ID = '$Id' ";
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * Move data From Database Row to member variable
     * -------------------------------------------------- */
    function LoadMemberValue($DbMan)
    {
        $this->m_Id       = $DbMan->f("Id");
        $this->m_Category = $DbMan->f("Category");
        $this->m_Name     = $DbMan->f("Name");
        $this->m_EMail    = $DbMan->f("EMail");
        $this->m_Homepage = $DbMan->f("Homepage");
        $this->m_Subject  = $DbMan->f("Subject");
        $this->m_Contents = $DbMan->f("Contents");
        $this->m_Wdate    = $DbMan->f("Wdate");
        $this->m_Vdate    = date("m/d H:i",$DbMan->f("Vdate"));
        $this->m_Ip       = $DbMan->f("Ip");
        $this->m_Hit      = $DbMan->f("Hit");
        $this->m_Ref      = $DbMan->f("Ref");
        $this->m_Step     = $DbMan->f("Step");
        $this->m_ReLevel  = $DbMan->f("ReLevel");
        $this->m_TopOrder = $DbMan->f("TopOrder");
        $this->m_ViewHtml = $DbMan->f("ViewHtml");
        $this->m_Pds      = $DbMan->f("Pds");
        
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetNewRef()
    {
        $Ret = "-1";
        $Query = "SELECT MAX(ref) as NewRef FROM $this->m_TableName";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $Ret = $this->m_DbMan->f("NewRef") + 1;
            }
        }
        else
        {
            $this->m_ErrMsg  = $this->m_DbMan->m_ErrMsg;
            $this->m_ErrCode = $this->m_DbMan->m_ErrCode;
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : private
     *
     * -------------------------------------------------- */
    function GetReplyDocNum()
    {

        $Query = "SELECT Ref, Step, ReLevel FROM $this->m_TableName WHERE id = '$this->m_ReplyId' ";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $Ref     = $this->m_DbMan->f("Ref");
                $Step    = $this->m_DbMan->f("Step") + 1;
                $ReLevel = $this->m_DbMan->f("ReLevel") + 1;
            }
        }
        else
        {
            $this->m_ErrMsg  = $this->m_DbMan->m_ErrMsg;
            $this->m_ErrCode = $this->m_DbMan->m_ErrCode;
        }
        return array($Ref, $Step, $ReLevel);
    }


    /* --------------------------------------------------
     * access : private
     *  ȣ õ Ÿ մϴ.
     *   Ref 
     * 亯    Խù  ɴϴ.
     * -------------------------------------------------- */
    function SetDocumentNum()
    {
        if($this->m_ReplyFlag)
        {
            list($this->m_Ref, $this->m_Step, $this->m_ReLevel) = $this->GetReplyDocNum();
        }
        else
        {
            $this->m_Ref     = $this->GetNewRef();
            $this->m_Step    = 0 ;
            $this->m_ReLevel = 0;
        }
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetFlagCheckBox($Value)
    {
        $Ret = $Value;
        if($Value != "T")
        {
            $Ret = "F";
        }
        return $Ret ;
    }


    /* --------------------------------------------------
     * access : public
     * override
     * $IP Update ÿ  
     * -------------------------------------------------- */
    function SetDataValue($DataValue, $IP = false)
    {
        $this->m_Category = $DataValue["Category"];
        $this->m_Name     = $DataValue["Name"];
        $this->m_EMail    = $DataValue["EMailID"]. "@" . $DataValue["EMailServer"] ;
        $this->m_Homepage = $DataValue["Homepage"];
        $this->m_Subject  = $DataValue["Subject"];
        $this->m_Contents = $DataValue["Contents"];
        $this->m_Passwd   = $DataValue["Passwd"];
        $this->m_Ip       = $IP;
        $this->m_TopOrder = $DataValue["TopOrder"];
        $this->m_ViewHtml = $this->GetFlagCheckBox($DataValue["ViewHtml"]);
        //Set Document Data. Ref, Step, ReLevel;
        $this->SetDocumentNum();
    }


    /* --------------------------------------------------
     * access : private
     * 亯  شϴ  Update ŵϴ.
     * -------------------------------------------------- */
    function UpdateReLevel()
    {
        $Ret = false;
        $Query = "UPDATE `$this->m_TableName` SET ReLevel = ReLevel + 1
                        WHERE Ref='$this->m_Ref'
                        AND ReLevel >= '$this->m_ReLevel' ";
        if($this->ExecuteQuery($Query))
        {
            $Ret = true;
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function GetInsertSQL()
    {
        return "INSERT INTO `$this->m_TableName`
                    (Category, Name,    EMail,
                     Homepage, Subject, Contents,
                     Passwd,   Wdate,   Ip,
                     Ref,      Step,    ReLevel,
                     TopOrder,  ViewHtml)
                    VALUES('$this->m_Category',         '$this->m_Name',    '$this->m_EMail',
                           '$this->m_Homepage',         '$this->m_Subject', '$this->m_Contents',
                            PASSWORD('$this->m_Passwd'), now(),              '$this->m_Ip',
                           '$this->m_Ref',              '$this->m_Step',    '$this->m_ReLevel',
                           '$this->m_TopOrder',          '$this->m_ViewHtml') ";

    }


    /* --------------------------------------------------
     * access : public
     * override
     * -------------------------------------------------- */
    function InsertData()
    {
        $Query = $this->GetInsertSQL();
        if($this->m_ReplyFlag)
        {
            $this->UpdateReLevel();
        }
        return $this->AffectOperate($Query);
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function GetNewId()
    {
        if($this->m_NewId == false)
        {
            $Query = "SELECT MAX(Id) as NewId FROM `$this->m_TableName` ";
            if($this->m_DbMan->query($Query))
            {
                if($this->m_DbMan->next_record())
                {
                    $this->m_NewId = $this->m_DbMan->f("NewId");
                }
            }
            return $this->m_NewId;
        }
        else
        {
            return $this->m_NewId;
        }
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function GetUpdateSQL($Id)
    {
        return "UPDATE `$this->m_TableName` SET
                Name     = '$this->m_Name',
                Category = '$this->m_Category',
                EMail    = '$this->m_EMail',
                Homepage = '$this->m_Homepage',
                Subject  = '$this->m_Subject',
                Contents = '$this->m_Contents',
                TopOrder = '$this->m_TopOrder',
                ViewHtml = '$this->m_ViewHtml'
                WHERE Id ='$Id' ";
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function CheckPassword($Id, $Password)
    {
        $Ret = false;
        $Query = "SELECT ID FROM `$this->m_TableName` WHERE Id='$Id' AND Passwd = PASSWORD('$Password') ";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $Ret = true;
            }
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function IncreaseHit($Id)
    {
        $Query = "UPDATE `$this->m_TableName` SET Hit = Hit + 1 WHERE Id = '$Id'";
        return $this->AffectOperate($Query);
    }


    /* --------------------------------------------------
     * access : public
     * override
     * -------------------------------------------------- */
    function GetDeleteSQL($Idx)
    {
        return "DELETE FROM `$this->m_TableName` WHERE Id = '$Idx'" ;

    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function DeleteData($Idx)
    {
        //   
        $Ret = true;
        $Query = "DELETE FROM `$this->m_TableName` WHERE Id = '$Idx'" ;
        $Ret = $Ret && $this->ExecuteQuery($Query);
        
        //  ε  
        $Upload = new KCUpload($this->m_TableName);
        $Ret = $Ret && $Upload->DeleteData($Idx);
        
        // Comment  
        $BoardComment = new KCBoardComment($this->m_TableName);
        $Ret = $Ret && $BoardComment->DeleteData($Idx, true);
        return $Ret;
    }

    /* --------------------------------------------------
     * access : public
     * ε  մϴ. 
     * -------------------------------------------------- */    
    function UpdatePds($Id)
    {
        $Ret = false;
        $Query = "SELECT COUNT(ID) Pds FROM `" . $this->m_TableName. "_Upload` WHERE BoardId = '$Id' ";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $Pds = $this->m_DbMan->f("Pds");                
                $Query = "UPDATE `$this->m_TableName` SET Pds = '$Pds' WHERE Id = '$Id'";
                $Ret = $this->ExecuteQuery($Query);
            }
        }
        return $Ret ;
    }
    

    /* --------------------------------------------------
     * access : public
     * Contents  Html  ̴ ƴϸ Text
     * Ұ  Ѵ.
     * -------------------------------------------------- */
    function GetContents()
    {
        if($this->m_ViewHtml == "F")
        {
            $Contents = str_replace("<", "&lt;", $this->m_Contents);
            $Contents = str_replace(">", "&gt;", $Contents);
            return $Contents;
        }
        else
        {
            return $this->m_Contents;
        }
    }


    /* --------------------------------------------------
     * access : private
     *
     * -------------------------------------------------- */
    function GetTopNearRef($Operator)
    {
        $Ret = "-1";
        if($Operator == "<")
        {
            $Order = "DESC";
        }
        else
        {
            $Order = "ASC";
        }


        $Query = "SELECT Ref FROM `$this->m_TableName` WHERE Ref $Operator '$this->m_Ref' GROUP BY Ref ORDER BY TopOrder $Order, Ref $Order, ReLevel limit 0, 1";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $Ret = $this->m_DbMan->f("Ref");
            }
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetPreNextId($Operator)
    {
        if($Operator == "<")
        {
            $Order = "DESC";
        }
        else
        {
            $Order = "ASC";
        }

        /*
        if($this->m_TopOrder == "0")
        {
            $Query = "SELECT Id FROM  `$this->m_TableName` WHERE Ref $Operator '$this->m_Ref'  ORDER BY  Ref $Order, ReLevel  limit 0, 1";
        }
        else
        {
            echo "haha";
            //$Query = "SELECT Id FROM  `$this->m_TableName` WHERE Ref = '". $this->GetTopNearRef($Operator) ."'";
            $Query = "SELECT Id FROM `$this->m_TableName` WHERE Ref $Operator '$this->m_Ref' GROUP BY Ref ORDER BY TopOrder $Order, Ref $Order, ReLevel limit 0, 1";
        }
        */

        $Ret = "-1";
        $Query = "SELECT Id FROM  `$this->m_TableName` WHERE Ref $Operator '$this->m_Ref'  ORDER BY  Ref $Order, ReLevel  limit 0, 1";
        //$Query = "set  @OrderIdx = 1;\n SELECT @OrderIdx := @OrderIdx + 1 AS OrderIdx, Id FROM  `$this->m_TableName` WHERE Ref $Operator '$this->m_Ref'  ORDER BY TopOrder $Order, Ref $Order, ReLevel  limit 0, 1";

        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $Ret = $this->m_DbMan->f("Id");
            }
        }
        return $Ret;
    }

    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetPreId()
    {
        return $this->GetPreNextId("<");
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetNextId()
    {
        return $this->GetPreNextId(">");
    }


    /* --------------------------------------------------
     * access :
     *   ȯؼ Ѱش.
     * -------------------------------------------------- */
    function GetEMailID()
    {
        $Ret = "";
        $Mails = split("@",$this->m_EMail);
        if(count($Mails) == 2)
        {
            $Ret = $Mails[0];
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetEMailServer()
    {
        $Ret = "";
        $Mails = split("@",$this->m_EMail);
        if(count($Mails) == 2)
        {
            $Ret = $Mails[1];
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetEMail()
    {
        if($this->m_EMail == "@")
        {
            return "";
        }
        else
        {
            return $this->m_EMail;
        }
    }
}

?>
