<?
/*
 ************************************************************************
 * File Name   : KCKAuth.php
 * Class Name  : KCKAuth
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KCAUTH"))      require(K_LIB_PATH . "/KCAuth.php");
if(!defined("KCUSERINFO"))  require(K_KLOCLASS_PATH . "/KCUserInfo.php");
if(!defined("KCPAGEADMIN")) require(K_KLOCLASS_PATH . "/KCPageAdmin.php");

define("KCKAUTH", true);
class KCKAuth extends KCAuth
{
    var $m_UserInfo;
    var $m_IsAuth;
    var $m_IsAuthFlag;
    var $m_IsAdmin;
    var $m_IsAdminFlag;
    var $m_IsStaff;
    var $m_IsStaffFlag;

    var $m_Domain              =  COOKIE_DOMAIN;
    var $COOKIE_NAME_USERID    = "KCUSERID";
    var $COOKIE_NAME_NAME      = "KCUSERNAME";
    var $COOKIE_NAME_USERTYPE  = "KCUSERUSERTYPE";
    var $COOKIE_NAME_UNIQUEID  = "KCUNIQUEID";
    var $COOKIE_NAMES;

    var $USER_LEVEL_ADMIN      = "1";
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCKAuth()
    {
        $this->KCAuth();
        $this->m_UserInfo    = new KCUserInfo;
        $this->m_IsAuth      = false;
        $this->m_IsAuthFlag  = false;
        $this->m_IsAdmin     = false;
        $this->m_IsAdminFlag = false;
        $this->m_IsStaff     = false;
        $this->m_IsStaffFlag = false;

        $this->COOKIE_NAMES  = array($this->COOKIE_NAME_USERID,
                                     $this->COOKIE_NAME_NAME,
                                     $this->COOKIE_NAME_USERTYPE,
                                     $this->COOKIE_NAME_UNIQUEID);
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function Login($UserId, $Passwd)
    {        
        $Ret = false;
        if($this->m_UserInfo->CheckUserLogin($UserId, $Passwd))
        {   
            $this->RawSetCookie($this->COOKIE_NAME_USERID,   $this->m_UserInfo->m_UserId);
            $this->RawSetCookie($this->COOKIE_NAME_NAME,     $this->m_UserInfo->m_Name);
            $this->RawSetCookie($this->COOKIE_NAME_USERTYPE, $this->m_UserInfo->m_UserType);
            $this->RawSetCookie($this->COOKIE_NAME_UNIQUEID, $this->m_UserInfo->m_UniqueId);                
            $Ret = true;            
        }
        else
        {
            $this->m_ErrMsg = " ̵, н带 Ȯ Ͻñ ٶϴ.";
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : protected
     * virtual function
     * -------------------------------------------------- */
    function RawSetCookie($Name, $Value)
    {        
        if($this->m_Domain == "")
        {
            setcookie($Name, $Value, 0, "/");
        }
        else
        {
            setcookie($Name, $Value, 0, "/", $this->m_Domain);
        }
        
        
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function IsAuth()
    {
        global $HTTP_COOKIE_VARS;
        $Ret = false;
        if($this->m_IsAuthFlag)
        {
            $Ret = $this->m_IsAuth;
        }
        else
        {
            $this->m_IsAuthFlag = true;
            if($this->IsSetUserCookie())
            {                
                if($this->m_UserInfo->LoadData($HTTP_COOKIE_VARS[$this->COOKIE_NAME_USERID]))
                {

                    if($this->m_UserInfo->m_UniqueId == $HTTP_COOKIE_VARS[$this->COOKIE_NAME_UNIQUEID])
                    {
                        $Ret            = true;
                        $this->m_IsAuth = true;
                    }
                }
            }
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function IsAdmin($PageName)
    {
        if($this->m_IsAdminFlag)
        {
            $Ret = $this->m_IsAdmin;
        }
        else
        {
            $this->m_IsAdminFlag = true;
            if($this->IsAuth())
            {
                // User Level 
                if($this->m_UserInfo->m_UserLevel == $this->USER_LEVEL_ADMIN)
                {
                    $Ret             = true;
                    $this->m_IsAdmin = true;
                }
                else
                {
                    // PageAdmin Ÿ ϴ ɴ.
                    $PageAdmin = new KCPageAdmin;
                    if($PageAdmin->IsAdmin($PageName, $this->m_UserInfo->m_UserId))
                    {
                        $Ret             = true;
                        $this->m_IsAdmin = true;
                    }
                }
            }
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * Ű Ű ̸ Ǿ ִ±⸦ ˻Ѵ.
     * Ű  ѹ   ֿ
     * COOKIE_NAME_USERID ˻Ѵ.
     * -------------------------------------------------- */
    function IsSetUserCookie()
    {
        $Ret = false;
        global $HTTP_COOKIE;
        if($HTTP_COOKIE[$this->COOKIE_NAME_USERID] != "")
        {
            $Ret = true;
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : public
     * override
     * -------------------------------------------------- */
    function Logout()
    {
        global $HTTP_COOKIE_VARS;
        for($i = 0 ; $i < count($this->COOKIE_NAMES) ; $i ++)
        {
            $this->RawSetCookie($this->COOKIE_NAMES[$i], "");
        }
        $this->AfterLogout();
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function AfterLogout()
    {
                
    }


    /* --------------------------------------------------
     * access : private
     *
     * -------------------------------------------------- */
    function GetCookie($Name)
    {
        global $HTTP_COOKIE_VARS;
        return $HTTP_COOKIE_VARS[$Name];
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetUserId()
    {
        return $this->GetCookie($this->COOKIE_NAME_USERID);
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */

    function GetName()
    {
        return $this->GetCookie($this->COOKIE_NAME_NAME);
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetUserType()
    {
        return $this->GetCookie($this->COOKIE_NAME_USERTYPE);
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetLoginTime()
    {
        return $this->m_UserInfo->m_LoginTime;
    }
}
?>