<?
/*
 ************************************************************************
 * File Name  : KCCommonUI.php
 * Class Name : KCCommonUI
 * version    : 1.0 ver
 * Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 * All Rights Reserved.
 * http://www.geonji.co.kr/~konlo
 * UPDATE : 2002 11 3
          : Add Template class in property
 ************************************************************************
 */


if(!defined("KCJSUTIL"))    require(K_LIB_PATH.    "/KCJSUtil.php");
if(!defined("KCCHECKDATA")) require(K_LIB_PATH.    "/KCCheckData.php");
if(!defined("TEMPLATE"))    require(K_LIB_PATH.    "/template.php");

define("KCCOMMONUI", true);
class KCCommonUI
{
    var $m_ErrMsg ;
    var $m_IsSetKey ;                         // Is set key
    var $m_Cmd ;
    var $m_CmdName ;
    var $m_JSUtil;
    var $m_CheckData;
    var $m_ViewState;
    var $m_Template ;
    var $m_IsSetHeader;
    var $m_IsSetBody;
    var $m_IsSetFooter;
    var $TEMPLATEHANDLE_BODY   = "HTMLDATA" ; //const string
    var $TEMPLATEHANDLE_HEADER = "HEADER" ;   //const string
    var $TEMPLATEHANDLE_FOOTER = "FOOTER" ;   //const string
    var $m_IsDisplayHeader;
    var $m_IsDisplayFooter;

    /* ---------------------------------------------
     * ctor.
     * ---------------------------------------------*/
    function KCCommonUI()
    {
        $this->m_JSUtil      = new KCJSUtil;
        $this->m_CheckData   = new KCCheckData;
        $this->m_Template    = new template;
        $this->m_ErrMsg      = "";
        $this->m_IsSetKey    = false;
        $this->m_Cmd         = false;
        $this->m_IsSetHeader = false;
        $this->m_IsSetBody   = false;
        $this->m_IsSetFooter = false;
    }


    /* ---------------------------------------------
     * Page Load
     * ---------------------------------------------*/
    function PageLoad()
    {
        $this->SetAuth();
        $this->SetCmd();
        //Set WebParameter to property
        $this->SetWebParameter();

        //Check Web Paramter
        $this->CheckWebParameter();
        // SendToAll source
        $this->BeforeHtml();
        $this->StartTemplate();
        $this->SetUIValue();        
        $this->SetFirstData();
        if($this->m_Cmd)
            $this->OnCmd();
        else
            $this->SetInitData();
        $this->SetLastData();
    }


    /* ---------------------------------------------
     * virtual function.
     * Set Template
     * Tempalte ʱȭ Ѵ.
     * ---------------------------------------------*/
    function StartTemplate()
    {
        $this->InitializeTemplate();
    }

   
    /* --------------------------------------------------
     * access : protected
     * virtual function 
     * <HTML>     մϴ.
     * 뵵 license ºκ  . 
     * -------------------------------------------------- */
    function BeforeHtml()
    {
        ;   
    }
    

    /* ---------------------------------------------
     * Check This page submit in command
     *   Command 
     * Command̸ ϰ Flag Ѵ.
     * ---------------------------------------------*/
    function SetCmd()
    {
        global $HTTP_POST_VARS;
        $CmdName = $HTTP_POST_VARS["command"];
        if($CmdName != "")
        {
            // Ư Class Method ȣߴ ɴ.
            $MethodInfo = explode(".", $CmdName);
            if(count($MethodInfo) == 2)
            {
                if(get_class($this) == strtolower($MethodInfo[0]))
                {
                    $this->m_CmdName = $MethodInfo[1];
                    $this->m_Cmd = true;
                }
            }
            else
            {
                $this->m_CmdName = $CmdName;
                $this->m_Cmd = true;
            }
        }
    }


    /* ---------------------------------------------
     * On Command Event Function.
     * Event Լ Ų.
     * ---------------------------------------------*/
    function OnCmd()
    {
        if(method_exists($this, $this->m_CmdName))
        {
            call_user_method($this->m_CmdName, $this, $this->m_CmdName);
        }
        else
        {
            $this->PrintError("߸ Command Դϴ. ϴ Method ϴ.");
            exit;
        }
    }


    /* ---------------------------------------------
     * virtual function.
     * On Event function.
     * ---------------------------------------------*/
    function OnEvent()
    {
        ;
    }


    /* ---------------------------------------------
     * virtual function.
     * Set Auth.
     * ---------------------------------------------*/
    function SetAuth()
    {
    }


    /* ---------------------------------------------
     * virtual function.
     * Set WebParameter to memeber variable.
     * ---------------------------------------------*/
    function SetWebParameter()
    {
        $this->SetExtraWebParameter();
    }


    /* ---------------------------------------------
     * virtual function.
     * Extra WebParameter is used, When Set Overriden
     * SetWebParameter.
     * ---------------------------------------------*/
    function SetExtraWebParameter()
    {

    }

    /* --------------------------------------------------
     * virtual function
     * access : protected
     * Set UI value.
     * -------------------------------------------------- */
    function SetUIValue()
    {
        ;
    }


    /* ---------------------------------------------
     * virtual function.
     * Before IsPostBack, Operation function
     * Event function ȣ   Ѵ.
     * ---------------------------------------------*/
    function SetFirstData()
    {

    }


    /* --------------------------------------------------
     * access : protected
     * virtual function
     *
     * -------------------------------------------------- */
    function SetInitData()
    {
        ;
    }


    /* ---------------------------------------------
     * virtual function.
     * After IsPostBack, Operation function
     *
     * ---------------------------------------------*/
    function SetLastData()
    {

    }


    /* ---------------------------------------------
     * virtual function.
     * Check invalid Web Paramter
     *       - For Function CommonUI Class
     * ---------------------------------------------*/
    function CheckWebParameter()
    {
        $this->ExtraCheckWebParameter();
        if(!$this->m_CheckData->CheckData())
        {
            $this->m_JSUtil->AlertBack($this->m_CheckData->m_ErrMsg);
        }
    }


    /* ---------------------------------------------
     * virtual function.
     * Check Extra Web Paramter. For Indivual Page Class
     * ---------------------------------------------*/
    function ExtraCheckWebParameter()
    {

    }


    /* ---------------------------------------------
     *
     * ---------------------------------------------*/
    function InitializeTemplate($Directory = false)
    {
        if($Directory != false)
            $this->m_Template->set_root($Directory);
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function SetTemplate($TemplateFile = false)
    {
        if($TemplateFile != false)
        {
            $this->m_Template->set_file(array($this->TEMPLATEHANDLE_BODY => $TemplateFile));
            $this->m_IsSetBody   = true;
        }
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function SetHeaderTemplate($TemplateFile)
    {
        if($TemplateFile != false)
        {
            $this->m_Template->set_file(array($this->TEMPLATEHANDLE_HEADER => $TemplateFile));
            $this->m_IsSetHeader = true;
        }
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function SetFooterTemplate($TemplateFile)
    {
        if($TemplateFile != false)
        {
            $this->m_Template->set_file(array($this->TEMPLATEHANDLE_FOOTER => $TemplateFile));
            $this->m_IsSetFooter = true;
        }
    }


    /* --------------------------------------------------
     * access : protected
     *
     * -------------------------------------------------- */
    function GetTemplateHandler()
    {
        $Handler = array();
        if($this->m_IsSetHeader)
            $Handler[count($Handler)] = $this->TEMPLATEHANDLE_HEADER;
        if($this->m_IsSetBody)
            $Handler[count($Handler)] = $this->TEMPLATEHANDLE_BODY;
        if($this->m_IsSetFooter)
            $Handler[count($Handler)] = $this->TEMPLATEHANDLE_FOOTER;
        return $Handler;
    }

    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetLoadTemplate()
    {
        $this->m_Template->parse("OUT", $this->GetTemplateHandler(), true);
        return $this->m_Template->getp("OUT");
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function SetBlock($Handle = "row", $Name = "rows")
    {
        $this->m_Template->set_block($this->TEMPLATEHANDLE_BODY, $Handle, $Name);
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function SetHeaderBlock($Handle = "row", $Name = "rows")
    {
        $this->m_Template->set_block($this->TEMPLATEHANDLE_HEADER, $Handle, $Name);
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function SetFooterBlock($Handle = "row", $Name = "rows")
    {
        $this->m_Template->set_block($this->TEMPLATEHANDLE_FOOTER, $Handle, $Name);
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function LoadTemplate()
    {
        $this->m_Template->parse("OUT", $this->GetTemplateHandler(), true);
        $this->m_Template->p("OUT");
    }


    /* --------------------------------------------------
     * access : public
     *  QueryString ״  ̵
     * -------------------------------------------------- */
    function GoNextPage($NextUrl)
    {
        global $QUERY_STRING;
        if($QUERY_STRING != "")
            $NextUrl = "$NextUrl?$QUERY_STRING";
        $this->m_JSUtil->Refresh($NextUrl);
        exit;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GoNextPageEx($NextUrl)
    {
        $this->m_JSUtil->Refresh($NextUrl);
        exit;
    }


    /* --------------------------------------------------
     * access : public
     *   ״  ٽ 
     * -------------------------------------------------- */
    function GoCurrentPage()
    {
        global $REQUEST_URI;
        $this->m_JSUtil->Refresh($REQUEST_URI);
        exit;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function PrintError($Msg)
    {
        echo $Msg;
    }
    
    
    /* --------------------------------------------------
     * access : public 
     * dctor.
     * -------------------------------------------------- */    
    function PageEnd()
    {
        ;        
    }
}
?>