<?
/*
 ************************************************************************
 * File Name  : KCSelectBox.php
 * Class Name : KCSelectBox
 * version    : Version. 0.1.0
 * Copyright 2001, 2002 Na Jong Sung <konlo@geonji.co.kr>
 * All Rights Reserved.
 * http://www.geonji.co.kr/~konlo
 ************************************************************************
 */


if(!defined("KCWEBCONTROL"))  require(K_LIB_PATH . "/KCWebControl.php");
if(!defined("KCITEM"))    require(K_LIB_PATH . "/KCItem.php");
define("KCSELECTBOX", TRUE);
class KCSelectBox extends KCWebControl
{
    var $m_TextField;
    var $m_ValueField;
    var $m_CurrnetValue;
    var $m_Items;
    var $m_SelectedIndex = -1;
    var $m_DbMan;
    var $m_DefaultValue;    
    var $m_AlternativeAttribute;

    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function KCSelectBox($name, $TextField = "", $ValueField = "")
    {
        $this->m_Name       = $name;
        $this->m_TextField  = $TextField;
        $this->m_ValueField = $ValueField;

        $this->KCWebControl($name);

        $this->m_Items = new KCArrayList;
        $this->m_DbMan = new KCDbSql;
        $this->m_DefaultValue= "-1";
    }


    /* --------------------------------------------------
     * access : public
     * virtual function
     * -------------------------------------------------- */
    function LoadData()
    {
        ;
    }


    /* --------------------------------------------------
     * virtual function.
     * Return Default value
     * --------------------------------------------------*/
    function GetDefaultValue()
    {
        return $this->m_DefaultValue;
    }


    /* --------------------------------------------------
     * access : protected
     * virtual function
     * -------------------------------------------------- */
    function SetDefaultValue($Value)
    {
        $this->m_DefaultValue = $Value;
    }


    /* --------------------------------------------------
     * virtual function.
     * Operation after Binding
     * --------------------------------------------------*/
    function AfterSBBind()
    {

    }


    /* --------------------------------------------------
     * Select Box Bind
     * --------------------------------------------------*/
    function SBBind($IndexValue = "-1")
    {
        //DefaultValue
        if($IndexValue == "-1")
        {
            $IndexValue = $this->GetDefaultValue();
        }
        $this->m_CurrnetValue = $IndexValue;
        $this->AfterSBBind();
        $this->SetIndexItem($IndexValue);
        return $this->GetSelectBox();
    }


    /* --------------------------------------------------
     * protected
     * Load DataBase data into m_Items from SQL
     * --------------------------------------------------*/
    function SetDataBaseItemsSQL($Query)
    {
        $result = $this->m_DbMan->query($Query);
        if($result)
        {
            $mItem = new KCItem;
            while($this->m_DbMan->next_record())
            {
                $mItem->m_Text  = $this->m_DbMan->f($this->m_TextField);
                $mItem->m_Value = $this->m_DbMan->f($this->m_ValueField);
                $this->m_Items->AddValue($mItem);
            }
        }
        else
        {
            $this->m_ErrMsg  = $this->m_DbMan->m_ErrMsg;
            $this->m_ErrCode = $this->m_DbMan->m_ErrCode;
        }
    }


    /* --------------------------------------------------
     * protected
     * Load DataBase data into m_Items from Array
     * --------------------------------------------------*/
    function SetDataBaseItemsArray($Items)
    {
        $mItem = new KCItem;
        while(list($Text, $Value) = each($Items))
        {
            $mItem->m_Text  = $Text;
            $mItem->m_Value = $Value;
            $this->m_Items->AddValue($mItem);
        }
    }

    /* --------------------------------------------------
     * private
     * return Select Box
     * --------------------------------------------------*/
    function GetSelectBox()
    {
        $OptionCounter = 0;
        $SelectBox = "<select name='$this->m_ControlName' ". $this->GetAttribute() ." >";
        for( $i = 0 ; $i < $this->m_Items->Count() ; $i ++)
        {
            if($i === $this->m_SelectedIndex)
                $Selected = "selected";
            else
                $Selected = "";

            // alternative attribute
            if( ($OptionCounter % 2) == 1)
            {
                $OptionAttri = $this->m_AlternativeAttribute;
            }
            else
            {
                $OptionAttri = "";
            }

            $mItem = $this->m_Items->GetAt($i);
            $SelectBox .="<option value=\"$mItem->m_Value\" $Selected $OptionAttri>$mItem->m_Text</option>\n";
            $OptionCounter ++;
        }
        $SelectBox .="</select>";
        return $SelectBox;
    }


    /* --------------------------------------------------
     * If selected value was setting ,
     * return true. otherwise return false
     * --------------------------------------------------*/
	function SetIndexItem($SelectedValue)
	{
		for( $i = 0 ; $i < $this->m_Items->Count() ; $i ++)
		{
		    $mItem = $this->m_Items->GetAt($i);
		    if($mItem->m_Value == $SelectedValue)
		    {
		        $this->m_SelectedIndex = $i ;
		        break;
		    }
		}
	}


	/* --------------------------------------------------
	 * access :
	 *
	 * -------------------------------------------------- */
	function SetAlternativeAttribute($Value)
	{
	    $this->m_AlternativeAttribute = $Value;
	}
}
?>